/*
 * File:   audio_receive.c
 *
 * Audio Reception Library
 *
 * Cheng Xing, Rene Zhang
 * cx34, rz99
 * December 2015
 */
#include "audio_receive.h"

void ar_receive(unsigned char *left_buffer, unsigned char *right_buffer) {
    // Check for the start of a packet
    int sync_count = 0;
    int received;
    while (sync_count < SYNC_NUM) {
        SpiChnGetRov(REC_CHAN, 1);
        received = SpiChnGetC(REC_CHAN);
        if ( received == SYNC_DATA )
            sync_count++;
        else
            sync_count = 0;
    }

    // Read data into the two given buffers.
    // First half of the packet is for the left buffer, and second half is for
    // the right buffer.
    int i;
    for ( i = 0; i < PKT_SIZE; i++) {
        unsigned char encoded_data = (unsigned char) SpiChnGetC(REC_CHANNEL);
        left_buffer[i]  = encoded_data >> 4;
        right_buffer[i] = encoded_data & 0xF;
    }
}
