/*
 * File:   audio_receive.h
 *
 * Audio Reception Library
 *
 * Cheng Xing, Rene Zhang
 * cx34, rz99
 * December 2015
 */
#ifndef __AUDIO_RECEIVE_H__
#define __AUDIO_RECEIVE_H__

#include "spi.h"

/***** Public Constants *****/

#define REC_CHAN SPI_CHANNEL1

// Number of samples in a single packet
#define PKT_SIZE 256
// Number of sync bytes to send
#define SYNC_NUM 4
// Synchronization byte
#define SYNC_DATA 0xDE

/***** Public Functions *****/

// Receives a single packet over the SPI channel
extern void ar_receive(unsigned char *left_buffer, unsigned char *right_buffer);

// Sets up the SPI channel
#define ar_setup() { \
    spi2_setup(); \
}

/***** End Public Functions *****/

#endif  /* __AUDIO_RECEIVE_H__ */
