/*
 * File:   dac.h
 *
 * Header file for DAC control
 *
 * Cheng Xing, Rene Zhang
 * cx34, rz99
 * December 2015
 */

#ifndef __DAC_H__
#define __DAC_H__

#include <plib.h>
#include "spi.h"

/***** Setup Parameters *****/

#define DAC_FREQ 44100
#define DAC_CHAN SPI_CHANNEL1

#define DAC_CS_CLEAR() mPORTBClearBits(BIT_4)
#define DAC_CS_SET() mPORTBSetBits(BIT_4)

/***** End Setup Parameter *****/

/***** Public Functions *****/

#define dac_write(data) { \
    SpiChnPutC(DAC_CHAN, data << 8); \
}

// DAC Peripheral Setup
// RPB13 - REFCLKO 11.2896 MHz
#define dac_setup() { \
    spi1_setup(); \
    mPORTBSetPinsDigitalOut(BIT_13); \
    PPSOutput(3, RPB13, REFCLKO); \
    mOSCREFOTRIMSet(44); \
    OSCREFConfig(OSC_REFOCON_SYSPLL, OSC_REFOCON_ON | OSC_REFOCON_OE, 7); \
}

/***** End Public Functions *****/

#endif  /* __DAC_H__ */
